
// ProjectorControllerDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ProjectorController.h"
#include "ProjectorControllerDlg.h"
#include "afxdialogex.h"
#include <Dbt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#ifdef IMPORT_LIBRARY_STATIC_STYLE
#ifdef _DEBUG
#pragma comment(lib,"../Debug/Projector.lib")
#else
#pragma comment(lib,"../Release/Projector.lib")
#endif
extern "C" __declspec(dllimport) IProjector* ProjectorDllCreate();
extern "C" __declspec(dllimport) void ProjectorDllDestroy(IProjector *pProjector);
#else
typedef IProjector *(ProjectorDllCreate)();
typedef int(ProjectorDllDestroy)(IProjector* pProjector);
#endif

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CProjectorControllerDlg Ի

bool CProjectorControllerDlg::s_bThreadExit = false;


CProjectorControllerDlg::CProjectorControllerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CProjectorControllerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_LOGO);
}

void CProjectorControllerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CProjectorControllerDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DEVICECHANGE()
	ON_WM_HSCROLL()
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CProjectorControllerDlg Ϣ

BOOL CProjectorControllerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶Իͼꡣ  ӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO:  ڴӶĳʼ
#ifdef IMPORT_LIBRARY_STATIC_STYLE
	m_Projector = ProjectorDllCreate();
#else
	m_hDLL = LoadLibrary(_T("Projector.dll"));
	if (m_hDLL) {
		ProjectorDllCreate* pDllCreate;
		pDllCreate = (ProjectorDllCreate*)GetProcAddress(m_hDLL, "ProjectorDllCreate");
		if (pDllCreate) {
			m_Projector = pDllCreate();
		}
	}
	else {
		AfxMessageBox(_T("Load Projector.dll failed!"));
		return FALSE;
	}
#endif
	m_hDetectThread = INVALID_HANDLE_VALUE;
	SetUILanguage();
	InitUI();
	RegisterDevNotify();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CProjectorControllerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣ  ʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CProjectorControllerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CProjectorControllerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void AppendTextToEdit(CEdit *pEdit, CString str)
{
	int nLength = pEdit->GetWindowTextLength();
	//ѡǰıĩ
	pEdit->SetSel(nLength, nLength);
	//l׷ı
	pEdit->ReplaceSel(str);
}

BOOL CProjectorControllerDlg::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	DEV_BROADCAST_HDR* dhr = (DEV_BROADCAST_HDR *)dwData;
	switch (nEventType)
	{
	case DBT_DEVICEREMOVECOMPLETE://Ƴ豸
		if (dhr->dbch_devicetype == DBT_DEVTYP_PORT)
		{
			PDEV_BROADCAST_PORT lpdbv = (PDEV_BROADCAST_PORT)dhr;
			CString cstrName(lpdbv->dbcp_name);//COM8
			LPCTSTR pName = cstrName.GetBuffer(0);
			char *c_name = new char[cstrName.GetLength() + 1];
			strcpy_s(c_name, cstrName.GetLength() + 1, CT2CA(pName));
			sscanf_s(c_name, "COM%d", &m_ComPort);
			if (m_ComOpened) {
				m_Projector->CloseCOM();
				m_ComOpened = false;
				CString strClose;
				strClose.Format(_T("[COM%2d] Close:\t\t[DONE]\r\n"), m_ComPort);
				AppendTextToEdit(m_EditLog, strClose);
				GetDlgItem(IDC_BTN_UART_CTRL)->SetWindowTextW(_T("Open COM"));
			}
			m_DetectedCOM = false;
			delete c_name;
		}
		break;
	case DBT_DEVICEARRIVAL://豸
		if (dhr->dbch_devicetype == DBT_DEVTYP_PORT)
		{
			CString strOpenCOM;
			strOpenCOM.LoadString(IDS_STR_COM_DETECED);
			PDEV_BROADCAST_PORT lpdbv = (PDEV_BROADCAST_PORT)dhr;
			CString cstrName(lpdbv->dbcp_name);
			LPCTSTR pName = cstrName.GetBuffer(0);
			char *c_name = new char[cstrName.GetLength() + 1];
			strcpy_s(c_name, cstrName.GetLength() + 1, CT2CA(pName));
			CString strTmp;
			sscanf_s(c_name, "COM%2d", &m_ComPort);
			printf("INFO: [COM%2d] Detected!\n", m_ComPort);
			strTmp.Format(_T("INFO: [COM%2d] Detected!\r\n"), m_ComPort);
			AppendTextToEdit(m_EditLog, strTmp);
			m_DetectedCOM = true;
		}
		break;
	default:
		break;
	}

	return TRUE;
}


bool CProjectorControllerDlg::InitUI()
{
#ifdef _DEBUG
	printf("========= INFO: DEBUG VERSION =========\n");
	printf("INFO: Waiting for Serial COM...\n");
#endif
	CFont *fontLog;
	fontLog = new CFont;
	int nFontHeight = 13;
	fontLog->CreateFont(nFontHeight, 0, 0, 0, 100,
		FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_SWISS, _T("Lucida Console"));// Arial

	m_EditLog = (CEdit *)GetDlgItem(IDC_EDIT_LOG);
	m_EditLog->SetLimitText(-1);
	m_EditLog->Clear();
	m_EditLog->SetFont(fontLog);
	AppendTextToEdit(m_EditLog, _T("==== GUIDE ====\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Insert Serial Port Firstly!\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Wait And Open UART\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Power On Device\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Get SW Version\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Test Item\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Power Down Device\r\n"));
	AppendTextToEdit(m_EditLog, _T("- Close UART or Exit Application.\r\n\r\n"));

	m_pSlidCtrl = (CSliderCtrl*)GetDlgItem(IDC_SLIDE_LED_CURRENT);
	m_pSlidCtrl->SetRange(0, 255);//ûΧ
	m_pSlidCtrl->SetTicFreq(20);//ÿ5λһ̶

	m_SlidVal = AfxGetApp()->GetProfileInt(_T("Settings"), _T("Current"), 0x7f);
	m_pSlidCtrl->SetPos(m_SlidVal);

	CFont *fontSlid;
	fontSlid = new CFont;
	nFontHeight = 22;
	fontSlid->CreateFont(nFontHeight, 0, 0, 0, 100,
		FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_SWISS, _T("Arial"));
	CString str;
	str.Format(_T("%d"), m_SlidVal);
	CEdit *editTemp = (CEdit *)GetDlgItem(IDC_EDIT_LED_CURRENT);
	editTemp->SetWindowTextW(str);
	editTemp->SetFont(fontSlid);
	//delete fontSlid;

	return true;
}

bool CProjectorControllerDlg::RegisterDevNotify()
{
	//עϢ
	DEV_BROADCAST_DEVICEINTERFACE dbdi;
	memset(&dbdi, 0, sizeof(dbdi));
	dbdi.dbcc_size = sizeof(dbdi);
	dbdi.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
	m_hDevNotify = RegisterDeviceNotification(this->GetSafeHwnd(), 
		&dbdi, DEVICE_NOTIFY_WINDOW_HANDLE | DEVICE_NOTIFY_ALL_INTERFACE_CLASSES);

	return true;
}


bool CProjectorControllerDlg::UnregisterDevNotify()
{
	if (NULL != m_hDevNotify)
	{
		UnregisterDeviceNotification(m_hDevNotify);
		m_hDevNotify = NULL;
	}

	return true;
}

#pragma warning(disable:4996)
bool CProjectorControllerDlg::SetUILanguage()
{
	if ((GetSystemDefaultLangID() == MAKELANGID(LANG_CHINESE, SUBLANG_CHINESE_SIMPLIFIED)) &&
		(GetSystemDefaultLangID() != MAKELANGID(LANG_CHINESE, SUBLANG_CHINESE_TRADITIONAL)) &&
		(GetSystemDefaultLangID() != MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US)))
	{
		OSVERSIONINFO ovs;
		ovs.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		if (::GetVersionEx(&ovs))
		{
			if (ovs.dwPlatformId == VER_PLATFORM_WIN32_NT && ovs.dwMajorVersion >= 6 &&
				ovs.dwMinorVersion >= 0)
			{
				SetThreadUILanguage(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US));
			}
			else
				SetThreadLocale(MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT));
		}
	}
	return TRUE;
}

BOOL CProjectorControllerDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// TODO:  ڴרô/û
	CString strValue;
	unsigned short red = 0;
	unsigned short green = 0;
	unsigned short blue = 0;
	bool ret = false;
	bool btn_pressed = true;

	switch (wParam) {
	case IDC_BTN_UART_CTRL:
		if (m_ComOpened) {
			m_Projector->CloseCOM();
			strValue.Format(_T("[COM%2d] Close:\t\t[DONE]\r\n"), m_ComPort);
			AppendTextToEdit(m_EditLog, strValue);
			//if (ret) {
			GetDlgItem(IDC_BTN_UART_CTRL)->SetWindowTextW(_T("Open COM"));
			m_ComOpened = false;
			return CDialogEx::OnCommand(wParam, lParam);
			//}
		}
		else {
			for (int port = 0; port < 0xff; port++) {
				ret = m_Projector->OpenCOM(port);
				if (ret) {
					m_ComPort = port;
					printf("INFO: [COM%2d] Open %s!\n", m_ComPort, ret ? "SUCCESS" : "FAILED");
					break;
				}
			}
			strValue.Format(_T("[COM%2d] Open:\t\t[%s]\r\n"), m_ComPort, ret ? _T("DONE") : _T("FAIL"));
			AppendTextToEdit(m_EditLog, strValue);
			if (ret) {
				GetDlgItem(IDC_BTN_UART_CTRL)->SetWindowTextW(_T("Close COM"));
				m_ComOpened = true;
			}
			else {
				m_ComOpened = false;
				return CDialogEx::OnCommand(wParam, lParam);
			}
		}
		break;
	case IDC_BTN_POWER_ON:
		ret = m_Projector->PowerOn();
		strValue.Format(_T("Power On:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_POWER_DOWN:
		ret = m_Projector->PowerDown();
		strValue.Format(_T("Power Down:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_LED_ON:
		ret = m_Projector->OpenLed();
		strValue.Format(_T("Set LED On:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_LED_OFF:
		ret = m_Projector->CloseLed();
		strValue.Format(_T("Set LED Off:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_GET_LED_STATUS:
		bool status;
		ret = m_Projector->GetLedStatus(&status);
		strValue.Format(_T("LED Status:\t\t[%4s]\r\n"), !ret ? _T("FAIL") : status ? _T("On") : _T("OFF"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_GET_WORK_TIME:
		short time;
		ret = m_Projector->GetWorktime(&time);
		if (ret) {
			strValue.Format(_T("Get Work Time: %d hour\r\n"), time);
		}
		else {
			strValue.Format(_T("%s\r\n"), _T("Get Work Time:\t\t[FAIL]"));
		}
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_RESET_WORK_TIME:
		ret = m_Projector->ResetWorktime();
		strValue.Format(_T("Reset Work Time:\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_REFRESH_HDMI:
		ret = m_Projector->RefreshHdmiSignal();
		strValue.Format(_T("Refresh HDMI:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_GET_TEMPERATURE:
		short t;
		ret = m_Projector->GetLedTemperature(&t);
		if (ret) {
			strValue.Format(_T("Get Temperature: %d \r\n"), t);
		}
		else {
			strValue.Format(_T("%s\r\n"), _T("Get Temperature:\t[FAIL]"));
		}
		AppendTextToEdit(m_EditLog, strValue);
		break;
	case IDC_BTN_SET_CURRENT:
		ret = m_Projector->SetCurrent(m_SlidVal, m_SlidVal, m_SlidVal);
		ret = m_Projector->SaveCurrent();
		strValue.Format(_T("Set Current:\t\t[%s]\r\n"), ret ? _T("DONE") : _T("FAIL"));
		AppendTextToEdit(m_EditLog, strValue);
		if (ret) {
			AfxGetApp()->WriteProfileInt(_T("Settings"), _T("Current"), m_SlidVal);
		}
		break;
	case IDC_BTN_GET_SW_VERSION:
		char version[0xff];
		ret = m_Projector->GetSWVersion(version);
		if (ret) {
			CString strVersion(version);
			strValue = _T("SW Version:\r\n") + strVersion + _T("\r\n");
		}
		else {
			strValue.Format(_T("%s\r\n"), _T("SW Version:\t\t[FAIL]"));
		}
		AppendTextToEdit(m_EditLog, strValue);
		break;
	default:
		btn_pressed = false;
		break;
	}
	if (btn_pressed) {
		if (!m_ComOpened) {
			strValue.Format(_T("WARN: NO Serial Port OPENED!\r\n"), m_ComPort);
			AppendTextToEdit(m_EditLog, strValue);
		}
	}

	return CDialogEx::OnCommand(wParam, lParam);
}


void CProjectorControllerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO:  ڴϢ/Ĭֵ
	m_SlidVal = m_pSlidCtrl->GetPos();
	CString str;
	str.Format(_T("%d"), m_SlidVal);
	GetDlgItem(IDC_EDIT_LED_CURRENT)->SetWindowTextW(str);

	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CProjectorControllerDlg::OnClose()
{
	// TODO:  ڴϢ/Ĭֵ
	//CloseDetectThread();
	if (m_ComOpened) {
		m_Projector->CloseCOM();
	}
#ifdef IMPORT_LIBRARY_STATIC_STYLE
	ProjectorDllDestroy(m_Projector);
#else
	if (m_hDLL){
		ProjectorDllDestroy* pDllDestroy;
		pDllDestroy = (ProjectorDllDestroy *)GetProcAddress(m_hDLL, "ProjectorDllDestroy");
		if (pDllDestroy) {
			pDllDestroy(m_Projector);
		}
		FreeLibrary(m_hDLL);
		m_hDLL = NULL;
	}
#endif
	CDialogEx::OnClose();
}
