
// ProjectorControllerDlg.h : ͷļ
//

#pragma once

#include "IProjector.h"

// CProjectorControllerDlg Ի
class CProjectorControllerDlg : public CDialogEx
{
// 
public:
	CProjectorControllerDlg(CWnd* pParent = NULL);	// ׼캯

// Ի
	enum { IDD = IDD_PROJECTORCONTROLLER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧


// ʵ
protected:
	HICON m_hIcon;
	HDEVNOTIFY  m_hDevNotify;
#ifndef IMPORT_LIBRARY_STATIC_STYLE
	HINSTANCE m_hDLL;
#endif
	IProjector* m_Projector;
	CEdit* m_EditStatus;
	CEdit* m_EditLog;
	bool m_ComOpened;
	CSliderCtrl *m_pSlidCtrl;
	unsigned short m_SlidVal;
	bool m_DetectedCOM;
	int m_ComPort;
	bool m_PowerStatus;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg BOOL OnDeviceChange(UINT nEventType, DWORD dwData);
	afx_msg void OnClose();
	DECLARE_MESSAGE_MAP()
public:
	bool RegisterDevNotify();
	bool UnregisterDevNotify();
	bool CProjectorControllerDlg::InitUI();
	bool CProjectorControllerDlg::CreateStatusBar();
	bool CProjectorControllerDlg::SetUILanguage();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	bool CProjectorControllerDlg::OpenDetectThread();
	bool CProjectorControllerDlg::CloseDetectThread();

private:
	volatile HANDLE m_hDetectThread;
	static bool s_bThreadExit;
	static UINT WINAPI DetectCOMThread(void* pParam);
};
