#include "stdafx.h"
#include "Projector.h"


extern "C" __declspec(dllexport) IProjector* ProjectorDllCreate();
extern "C" __declspec(dllexport) void ProjectorDllDestroy(IProjector *pProjector);


__declspec(dllexport) IProjector* ProjectorDllCreate()
{
	return new CProjector();
}

__declspec(dllexport) void ProjectorDllDestroy(IProjector *pProjector)
{
	if (pProjector != NULL) {
		delete pProjector;
	}
	pProjector = NULL;
}
