// Projector.h : Projector DLL ͷļ
//

#pragma once

#ifndef __AFXWIN_H__
	#error "ڰļ֮ǰstdafx.h PCH ļ"
#endif

#include "resource.h"		// 


// CProjectorApp
// йشʵֵϢ Projector.cpp
//

class CProjectorApp : public CWinApp
{
public:
	CProjectorApp();

// д
public:
	virtual BOOL InitInstance();

	DECLARE_MESSAGE_MAP()
};

#include "IProjector.h"
#include "SerialPort.h"

//#ifdef CREATEDELL_API_DU
//#else
/**
 * ʱͷļμӱ룬.cppļȶ壬ͷļ;
 * ⲿʹʱΪdllexportڲʱΪdllimport
 * __declspec(dllexport) 
 */
//#define CREATEDELL_API_DU _declspec(dllimport)
//#endif	//Ҫõࣩࣨ

#define STRING_LENGTH_MAX	0xff

class CProjector : public IProjector
{
public:
	CProjector(void);
	virtual ~CProjector(void);
	bool OpenCOM(int port);
	bool CloseCOM();
	bool PowerOn();
	bool PowerDown();
	bool OpenLed();
	bool CloseLed();
	bool GetLedStatus(bool *status);
	bool SaveCurrent();
	bool RefreshHdmiSignal();
	bool SetCurrent(unsigned short r, unsigned short g, unsigned short b);
	bool GetLedTemperature(short *T);
	bool GetWorktime(short *time);
	bool ResetWorktime();
	bool GetSWVersion(char *version);

protected:
	CSerialPort mSerialPort;

private:
	void EmptyComBuffer();
	bool SendCmd(unsigned char cmd, struct data_pkg *data, struct data_pkg *rcv_pkg);
	int GetCmdResult(unsigned char cmd, unsigned char *buf);
};